<template>
  <div class="wrapper">
    <div class="container-fuild">
      <div id="headTitle">
        <Logo />
        <h1 id="title" _msttexthash="48503" _msthash="2">{{ i18ntext.lngText('pro-stock') }}</h1>

      </div>
      <Header />
      <ol id="topicPath">
        <li style="margin: -32px 0px 0px 328px">
          <router-link to="viewproduct">
            <a href="dashbaord"> {{ i18ntext.lngText('pro-stock') }} </a>
          </router-link>
        </li>
      </ol>
    </div>
    <div class="search-box">
      <div id="product">
        <div class="search-box">
          <div class="search-box-title" id="Bars">
            <div id="bar" style="width: 90%">
              <router-link to="product" data-bs-toggle="dropdown" aria-expanded="false">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1" style="background-color: #29a5a5;">
                  <i class="fas fa-plus" style="padding-right: 5px"> </i>
                  {{ i18ntext.lngText('add-pro') }}
                </a>
              </router-link>
              <ul class="dropdown-menu" style="padding:6px;">
                <li>
                  <router-link to="/product">
                    <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-bottom: 10px;margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                      <i class="fas fa-plus"> </i>
                      {{ i18ntext.lngText('add-pro') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/viewproduct">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-eye" aria-hidden="true"></i>
                      {{ i18ntext.lngText('pro_view') }}
                    </a>
                  </router-link>
                </li>
              </ul>
              <!-- Room-->
              <router-link to="product" data-bs-toggle="dropdown" aria-expanded="false">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1" style="background-color: #29a5a5;">
                  <i class="fas fa-plus" style="padding-right: 5px"> </i>
                  {{ i18ntext.lngText('add_room') }}
                </a>
              </router-link>
              <ul class="dropdown-menu" style="padding:6px;">
                <li>
                  <router-link to="/room">
                    <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-bottom: 10px;margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                      <i class="fas fa-plus"> </i>
                      {{ i18ntext.lngText('room') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/view_room">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-eye" aria-hidden="true"></i>
                      {{ i18ntext.lngText('view_room') }}
                    </a>
                  </router-link>
                </li>
              </ul>
              <!-- Room -->
              <router-link to="brands" data-bs-toggle="dropdown" aria-expanded="false">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-cog" aria-hidden="true"></i>
                  {{ i18ntext.lngText('set-pro') }}
                </a>
              </router-link>

              <ul class="dropdown-menu" id="drop_menu">
                <li>
                  <router-link to="/Brands">
                    <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-tags" aria-hidden="true"></i>
                      {{ i18ntext.lngText('brands') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/supplies">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                    <i class="fa fa-truck" aria-hidden="true"></i>
                      {{ i18ntext.lngText('supplier') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/unitcode">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                    <i class="fa fa-th-large" aria-hidden="true"></i>
                      {{ i18ntext.lngText('unit-size') }}
                    </a>
                  </router-link>
                </li>
                <li>
                    <router-link to="/pro_unittype">
                      <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                      margin-right: 0;width: 100%;text-align: left;">
                       <i class="fa fa-th-large" aria-hidden="true"></i>
                        {{ i18ntext.lngText('unittype') }}
                      </a>
                    </router-link>
                  </li>
                <li>
                    <router-link to="/Group">
                      <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                      margin-right: 0;width: 100%;text-align: left;">
                       <i class="fa fa-flask" aria-hidden="true"></i>
                        {{ i18ntext.lngText('diangosis') }}
                      </a>
                    </router-link>
                  </li>
                <li>
                  <router-link to="/Category">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                    <i class="fa fa-box-open"></i>
                      {{ i18ntext.lngText('category') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/room_type">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                   <i class="fa fa-university" aria-hidden="true"></i>
                      {{ i18ntext.lngText('room_type') }}
                    </a>
                  </router-link>
                </li>

                <li>
                  <router-link to="/room_furniture">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                    <i class="fa fa-hourglass-half" aria-hidden="true"></i>
                      {{ i18ntext.lngText('room_furniture') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/booking_line">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                    <i class="fa fa-life-ring" aria-hidden="true"></i>
                      {{ i18ntext.lngText('booking_line') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/bookingone">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">

                   <i class="fa fa-envelope" aria-hidden="true"></i>
                      {{ i18ntext.lngText('bookingone') }}
                    </a>
                  </router-link>
                </li>
                <li>
                <router-link to="/furniture">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">

                    <i class="fa fa-bed" aria-hidden="true"></i>
                      {{ i18ntext.lngText('furniture') }}
                    </a>
                  </router-link>
                </li>
                <li>
                <router-link to="/room_price">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">

                    <i class="fa fa-university" aria-hidden="true"></i>
                      {{ i18ntext.lngText('room_price') }}
                    </a>
                  </router-link>
                </li>



                <li>
                  <router-link to="/exchangerate">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-money-bill-wave"></i>
                      {{ i18ntext.lngText('exchangerate') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/paymenMethod">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-money-check"></i>
                      {{ i18ntext.lngText('payment') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/Group">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-flask" aria-hidden="true"></i>
                      {{ i18ntext.lngText('groupservice') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/company">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                    margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-building" aria-hidden="true"></i>
                      {{ i18ntext.lngText('company') }}
                    </a>
                  </router-link>
                </li>
              </ul>

              <router-link to="menupurchase" data-bs-toggle="dropdown" aria-expanded="false">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-shopping-cart" aria-hidden="true"></i>
                  {{ i18ntext.lngText('purchase_order') }}
                </a>
              </router-link>
              <ul class="dropdown-menu" id="drop_menu">
                <li>
                  <router-link to="/Purchasview">
                    <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
                      margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-cart-plus"></i>
                      {{ i18ntext.lngText('purchase_order') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/viewrecept">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-cart-arrow-down" aria-hidden="true"></i>
                      {{ i18ntext.lngText('recept_order') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/serailcode">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-barcode"></i>
                      {{ i18ntext.lngText('serial') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/paymenview">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-eye"></i>
                      {{ i18ntext.lngText('payment_view') }}
                    </a>
                  </router-link>
                </li>
              </ul>
              <router-link to="/stockonhand" data-bs-toggle="dropdown" aria-expanded="false">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1">
                  <i class="fa fa-shopping-basket" aria-hidden="true"></i>
                  {{ i18ntext.lngText('stock') }}
                </a>
              </router-link>
              <ul class="dropdown-menu" id="drop_menu">
                <li>
                  <router-link to="/stockonhand">
                    <a class="btn-radius btn btn-sm down" href="#" style="background-color: #29a5a5; border: #22adb763 1px solid;
                      margin-top: 0;margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-prescription-bottle"></i>
                      {{ i18ntext.lngText('onhands') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/stockonhand_date">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-calendar-plus"></i>
                      {{ i18ntext.lngText('onhand-date') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/beginningstock">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
              margin-right: 0;width: 100%;text-align: left;">
                     <i class="fa fa-tape"></i>
                      {{ i18ntext.lngText('begin-stock') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/viewstockcount">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                      margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-calculator"></i>
                      {{ i18ntext.lngText('stock-count') }}
                    </a>
                  </router-link>
                </li>
                <li>
                  <router-link to="/stocktransection">
                    <a class="btn-radius btn btn-sm down" href="#" id="bar-1" style="background-color: #29a5a5; border: #22adb763 1px solid;
                      margin-right: 0;width: 100%;text-align: left;">
                      <i class="fa fa-recycle" aria-hidden="true"></i>
                      {{ i18ntext.lngText('stock-tran') }}
                    </a>
                  </router-link>
                </li>
              </ul>
              <router-link to="/stockalert">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1" style="border: #22adb763 1px solid;
                  margin-right: 0;width: 100%;">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    {{ i18ntext.lngText('stock-alert') }}
                  <span style="
                  background-color: red;
                  border-radius: 5px;
                  padding: 3px;
                  box-shadow: 1px 1px;
                  color: #333;">
                  {{ stockcount }} {{ i18ntext.lngText('item') }}
                </span>
                </a>
              </router-link>
              <router-link to="/ex_alert">
                <a class="btn-radius btn btn-sm" href="#" id="bar-1" style="border: #22adb763 1px solid;
                  margin-right: 0;width: 100%;">
                    <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    {{ i18ntext.lngText('expire-alert1') }}
                  <span style="
                  background-color: red;
                  border-radius: 5px;
                  padding: 3px;
                  box-shadow: 1px 1px;
                  color: #333;">
                  {{ count_expire }} {{ i18ntext.lngText('item') }}
                </span>
                </a>
              </router-link>
            </div>
            <div id="right" style="width: 10%">
              <a class="btn-radius bt-pn btn btn-sm" data-bs-toggle="dropdown" aria-expanded="false"
                style="float: right; color: #f8f5b4; margin-top: -2px; margin-right: 11px">
                <i class="fas fa-plus" style="padding-right: 5px"> </i>
                {{ i18ntext.lngText('menu') }}
              </a>
              <ul class="dropdown-menu">
                <li>
                  <a  class="dropdown-item btn btn-primary" data-bs-toggle="modal"
                    data-bs-target="#staticboomId" tabindex="10028"><i class="fa fa-print" aria-hidden="true"></i> {{
                      i18ntext.lngText('print') }}</a>
                </li>
                <li>
                  <a class="dropdown-item btn btn-primary" data-bs-toggle="modal" data-bs-target="#printpart"
                    tabindex="10028"><i class="fa fa-print" aria-hidden="true"></i> {{ i18ntext.lngText('print') }}
                    Product Detail</a>
                </li>

                <li>
                  <a href="#" @click="save()" class="dropdown-item btn btn-primary" data-bs-toggle="modal"
                    data-bs-target="#statiex-import" tabindex="10028">
                    <i class="fas fa-file-import"></i>
                    {{ i18ntext.lngText('imp') }}
                  </a>
                </li>
                <li>
                  <a href="#" class="dropdown-item btn btn-primary" data-bs-toggle="modal"
                    data-bs-target="#statiex-import" tabindex="10028" @click="exportSheet()">
                    <i class="fas fa-file-import"></i>
                    {{ i18ntext.lngText('ept') }}
                  </a>
                </li>
              </ul>
            </div>
          </div>
        </div>
        <div class="box">
          <div class="box-content">
            <table width="100%" border="0" cellpadding="0" cellspacing="0" class="table table-striped br-table">
              <thead>
                <tr class="header-table">
                  <th colspan="6" style="width: 35em">
                    <input autocomplete="off" @input="getproduct()"  type="search" class="text" v-model="search.name"
                      placeholder="No, Generic Name, Name Kh, Price" style="width: 100%" />
                  </th>
                  <th>
                    <div class="dropdown d-flex">
                      <button  @onmouseout="prooductboom()" style="width: 8em !important"
                        class="dropdown-toggle string_zen clear_text text select-menu" type="button"
                        id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false" size="50">
                        <span v-if="search.brand == ''">Brand</span>
                        <span v-else>{{ search.brand }}</span>
                        <i class="fa fa-chevron-down" style="margin-top: 3px"></i>
                      </button>
                      <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1">
                        <p>
                          <input autocomplete="off" v-model="brand" @input="searchBrand(brand)"
                            class="string_zen clear_text text search-pro-field" size="50" type="text" />
                        </p>
                        <ul style="list-style: none" class="scrollable-menu">
                          <li v-for="brand in brands" :value="brand.brand_code"
                            @click="getproductsetting(brand, 'brand')">
                            <div class="menu-item">
                              <p>{{ brand.brand_name }}</p>
                            </div>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </th>
                  <th>
                    <div class="dropdown d-flex">
                      <button  @onmouseout="prooductboom()" style="width: 9em !important"
                        class="dropdown-toggle string_zen clear_text text select-menu" type="button"
                        id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false" size="50">
                        <span v-if="search.unit == ''">Unit</span>
                        <span v-else>{{ search.unit }}</span>
                        <i class="fa fa-chevron-down" style="margin-top: 3px"></i>
                      </button>

                      <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1">
                        <p>
                          <input autocomplete="off" v-model="unit_code" @input="searchUnit(unit_code)"
                            class="string_zen clear_text text search-pro-field" size="50" type="text" />
                        </p>
                        <ul style="list-style: none" class="scrollable-menu">
                          <li v-for="uint in uints" :value="uint.unit_code" @click="getproductsetting(uint, 'stockunit')">
                            <div class="menu-item">
                              <p>{{ uint.unit_of_measure }}</p>
                            </div>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </th>
                  <th>
                    <div class="dropdown d-flex">
                      <button  @onmouseout="prooductboom()" style="width: 9em !important"
                        class="dropdown-toggle string_zen clear_text text select-menu" type="button"
                        id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false" size="50">
                        <span v-if="search.category == ''">Category</span>
                        <span v-else>{{ search.category }}</span>

                        <i class="fa fa-chevron-down" style="margin-top: 3px"></i>
                      </button>

                      <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1">
                        <p>
                          <input autocomplete="off" v-model="category" @input="searchCategory(category)"
                            class="string_zen clear_text text search-pro-field" size="50" type="text" />
                        </p>
                        <ul style="list-style: none" class="scrollable-menu">
                          <li v-for="categor in category" :value="categor.cat_code"
                            @click="getproductsetting(categor, 'category')">
                            <div class="menu-item">
                              <p>{{ categor.cat_name }}</p>
                            </div>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </th>
                  <th>
                    <div class="dropdown d-flex">
                      <button  @onmouseout="prooductboom()" style="width: 8em !important"
                        class="dropdown-toggle string_zen clear_text text select-menu" type="button"
                        id="dropdownMenuButton1" data-bs-toggle="dropdown" aria-expanded="false" size="50">
                        <span v-if="search.supplier == ''">Supplier</span>
                        <span v-else>{{ search.supplier }}</span>
                        <i class="fa fa-chevron-down" style="margin-top: 3px"></i>
                      </button>
                      <div class="dropdown-menu each-drop-menu" aria-labelledby="dropdownMenuButton1">
                        <p>
                          <input autocomplete="off" v-model="supplier" @input="searchSupplier(supplier)"
                            class="string_zen clear_text text search-pro-field" size="50" type="text" />
                        </p>
                        <ul style="list-style: none" class="scrollable-menu">
                          <li v-for="suppliyer in suppliyers" :value="suppliyer.sup_code"
                            @click="getproductsetting(suppliyer, 'supplier')">
                            <div class="menu-item">
                              <p>{{ suppliyer.sup_name }}</p>
                            </div>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </th>
                  <th width="14%">
                    <div class="button type2" id="uniform-undefined">
                      <span @click="getproduct()"><input autocomplete="off" type="button" class="type2" tabindex="10025" value="display"
                          style="opacity: 0; width: 54px" /><i class="fa fa-search"></i> {{ i18ntext.lngText('search')
                          }}</span>
                    </div>
                  </th>
                </tr>
                <tr class="header-table">
                  <th width="4%">{{ i18ntext.lngText('no') }}</th>
                  <th width="5%">{{ i18ntext.lngText('img') }}</th>
                  <th width="11%">{{ i18ntext.lngText('product_no') }}</th>
                  <th width="10%">{{ i18ntext.lngText('brands') }}</th>
                  <th width="13%">{{ i18ntext.lngText('gen_name') }}</th>
                  <th width="13%">{{ i18ntext.lngText('kh_name') }}</th>
                  <th width="9%">{{ i18ntext.lngText('category') }}</th>
                  <!-- <th width="9%">{{ i18ntext.lngText('sale_price') }}</th> -->
                  <th width="6%">{{ i18ntext.lngText('unit_price') }}</th>
                  <th width="9%">{{ i18ntext.lngText('pro_type') }}</th>
                  <th width="9%">{{ i18ntext.lngText('unittype') }}</th>
                  <th width="9%"></th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(product, index) in products.data" :key="index">
                  <td>{{ 15*(number - 1)  + (index + 1) }}</td>
                  <td>
                    <img v-if="product.image_url != null && product.image_url != ''" alt="" height="40" :src="'/img/product/' + product.image_url" width="40" />
                    <img v-else src="img/1707295756.jpeg" alt="image" height="40" width="40"/>
                  </td>
                  <td>
                    {{ product.product_no }}
                  </td>
                  <td>
                    {{ product.brand_code }}
                  </td>
                  <td>
                    {{ product.description }}
                  </td>
                  <td>
                    {{ product.description_2 }}
                  </td>

                  <td>
                    {{ product.cat_code }}
                  </td>
                  <!-- <td style="text-align: right">
                    {{ Number(product.inventory).toLocaleString() }}
                    <span style="text-align: left; color: rgb(17, 38, 235)">{{
                      product.stock_unit_of_measure_code
                    }}</span>
                  </td> -->
                  <td style="text-align: right">
                    {{ formatPrice(product.unit_price) }}$
                  </td>
                  <td>
                    {{ product.type }}
                  </td>
                  <td>
                    {{ product.variant_code }}
                  </td>
                  <td>
                    <div style="
                        display: flex;
                        flex-direction: row;
                        justify-content: space-around;
                        align-items: center;
                      ">
                      <div @click="getEdit(product.product_no)" class="button type2" id="uniform-undefined">
                        <span><input autocomplete="off" type="button" class="type2" style="opacity: 0; width: 54px" /><i
                            class="fa fa-edit"></i> {{ i18ntext.lngText('update') }}</span>
                      </div>
                      <div class="button type2" id="uniform-undefined" data-bs-toggle="modal" data-bs-target="#serialsave"
                        @click="getDelete(product)">
                        <span><input autocomplete="off" type="button" class="type2" tabindex="10025" value="display"
                            style="opacity: 0; width: 54px" /><i class="fa fa-trash" aria-hidden="true"></i> {{
                              i18ntext.lngText('Delete') }}</span>
                      </div>
                    </div>
                  </td>
                  <div class="modal fade ui-modal" id="serialsave" data-bs-backdrop="static" data-bs-keyboard="false"
                    tabindex="-1" aria-labelledby="clearconfirm" aria-hidden="true">
                    <div class="modal-dialog smallpopup" id="nonbackgroundboom">
                      <div class="modal-content ui-dialog" style="box-shadow: none">
                        <div class="ui-widget-header">
                          <h5 class="modal-title" id="exampleModalLabel">
                            <span class="ui-dialog-title" id="ui-dialog-title-modal-edit-dialog">{{
                              i18ntext.lngText('confirm_message') }}</span>
                          </h5>

                        </div>
                        <div class="ui-dialog-content" style="background-color: #fff">
                          <div class="modal-body" style="font-size: 15px">
                            {{ i18ntext.lngText('mes-del') }} {{ viewID }} ?
                          </div>
                          <div class="modal-footer">
                            <div class="button type2" id="uniform-undefined" data-bs-dismiss="modal">
                              <span>No<input autocomplete="off" type="button" class="type2" tabindex="10008" value="No"
                                  style="width: 89px; opacity: 0" />
                              </span>
                            </div>
                            <div class="button type2" data-bs-dismiss="modal" @click="DeletePro(product)">
                              <span>{{ product.inactived }}</span>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </tr>
              </tbody>
            </table>
          </div>
          <div class="box-footer-pagination">
            <pagination :limit="2" :data="products" @pagination-change-page="getproduct" />
          </div>
        </div>
      </div>
    </div>
  </div>

  <div class="modal fade ui-modal" id="statiex-import" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
    aria-labelledby="staticboomId" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title in-header" id="staticBackdropLabel">
            <i class="fa fa-print" aria-hidden="true"></i> {{ excel }} to Docutment:
            {{ form.document_no }} , {{ form.description }}
          </h5>
          <a href="#" class="ui-dialog-titlebar-close ui-corner-all" role="button" data-bs-dismiss="modal">
            <span class="ui-icon ui-icon-closethick">close</span></a>
        </div>
        <div id="purchaseorder">
          <div class="card">
            <div class="card-body">
              <div class="container mb-5 mt-3">
                <div class="row d-flex align-items-baseline">
                  <div class="col-xl-9"></div>
                  <hr />
                </div>

                <div class="container">
                  <div class="col-md-12">
                    <div class="text-center">
                      <h3 v-if="excel == 'Import'" class="title-purchase" id="titlered">
                        {{ excel }} {{ exefile }} from Excel
                      </h3>
                      <h3 v-else class="title-purchase" id="titlered">
                        {{ excel }} To Excel
                      </h3>
                    </div>
                  </div>
                  <div class="row my-2 mx-1 justify-content-center table-padding-bot customsroll">
                    <table class="table table-striped table-borderless" id="exceldata">
                      <thead style="background-color: #84b0ca" class="text-white">
                        <tr>
                          <th style="width: 12%">{{ i18ntext.lngText('no') }}</th>
                          <th style="width: 7%">{{ i18ntext.lngText('brands') }}</th>
                          <th style="width: 15%">{{ i18ntext.lngText('gen_name') }}</th>
                          <th style="width: 15%">{{ i18ntext.lngText('kh_name') }}</th>
                          <th style="width: 12%">{{ i18ntext.lngText('category') }}</th>
                          <th style="width: 7%">{{ i18ntext.lngText('sale_price') }}</th>
                          <th style="width: 12%">{{ i18ntext.lngText('pro_type') }}</th>
                          <th style="width: 7%">{{ i18ntext.lngText('supplier') }}</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="(purchaseLine, index) in items" :key="index">
                          <th v-if="purchaseLine.product_no != ''" style="width: 12%">
                            {{ purchaseLine.product_no }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 12%">
                            {{ purchaseLine.brand_code }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 15%">
                            {{ purchaseLine.description }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 15%">
                            {{ purchaseLine.description_2 }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 12%">
                            {{ purchaseLine.cat_code }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 12%">
                            {{ purchaseLine.unit_price }}{{ purchaseLine.curency_code }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 12%">
                            {{ purchaseLine.type }}
                          </th>
                          <th v-if="purchaseLine.product_no != ''" style="width: 12%">
                            {{ purchaseLine.sup_code }}
                          </th>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <hr />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <a v-if="excel == 'Import'" class="btn-purchase btn-light text-capitalize" data-bs-dismiss="modal"
            data-mdb-ripple-color="dark" @click="saveprulink()"><i class="fas fa-save"></i> {{
              i18ntext.lngText('save-data') }}</a>
          <a v-if="excel == 'Import'" class="btn-purchase btn-light text-capitalize" data-mdb-ripple-color="dark"><i
              class="fas fa-file-excel"></i> {{ excel }} Form excel</a>
          <input autocomplete="off" v-if="excel == 'Import'" type="file" @change="getExcelData" name="select_file" />
          <a v-else class="btn-purchase btn-light text-capitalize" data-bs-dismiss="modal" data-mdb-ripple-color="dark"
            @click="exportdataExcel()"><i class="fas fa-save"></i> {{ i18ntext.lngText('save-data') }}</a>
        </div>
      </div>
    </div>
  </div>

  <div id="myModalauto" class="lsky">
    <div class="lsky-content">
      <p>{{ massege }}</p>
    </div>
  </div>
  <div class="modal fade ui-modal" id="staticboomId" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
    aria-labelledby="staticboomId" aria-hidden="true">
    <div class="modal-dialog" style="max-width: 95% !important">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title in-header" id="staticBackdropLabel">
            <i class="fa fa-print" aria-hidden="true"></i> {{ i18ntext.lngText('print') }}
          </h5>
          <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
        </div>
        <div class="ui-dialog-content">
          <div class="card">
            <div class="card-body">
              <div class="mt-3 print-size">
                <div class="row d-flex align-items-baseline">
                  <div class="col-xl-9"></div>
                  <hr />
                </div>
                <div style="padding: 0 50px 0 50px;" id="printProduct">
                  <div class="col-md-12">
                    <div class="text-center">
                      <h3 class="title-purchase">{{ i18ntext.lngText('pro_rep') }}</h3>
                    </div>
                  </div>

                  <div class="col-container">
                    <div class="col1" style="width: 55%">
                      <p class="p-bg font-size p-pad">{{ i18ntext.lngText('com-name') }}</p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('name') }} :</span>
                        <span id="fon">{{ company.company_name }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('phone') }} :</span>
                        <span id="fon">{{ company.company_Phone }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('email') }} :</span>
                        <span id="fon">{{ company.company_Email }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('address') }} :</span>
                        <span id="fon">{{ company.company_Address }}</span>
                      </p>
                    </div>
                    <div class="col2">
                      <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('date') }}</p>
                      <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                      <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('pro_ct') }}</p>
                      <p class="text-center p-mg" id="fon">{{ dataPrint.length }}</p>
                    </div>
                  </div>
                  <div class="my-2 justify-content-center">
                    <table id="pr-tb">
                      <thead>
                        <tr class="p-bg">
                          <th class="text-center" style>{{ i18ntext.lngText('img') }}</th>
                          <th class="text-center" style="width:10%">{{ i18ntext.lngText('brand_name') }}</th>
                          <th class="text-center" style="width:15%">{{ i18ntext.lngText('gen_name') }}</th>
                          <th class="text-center">{{ i18ntext.lngText('pro-u') }}</th>
                          <th class="text-center">{{ i18ntext.lngText('category') }}</th>
                          <th class="text-center" >{{ i18ntext.lngText('price') }}</th>
                          <th class="text-center" >{{ i18ntext.lngText('supplier') }}</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="(product, index) in dataPrint" :key="index">
                          <td style="padding-right: 5px">
                            <img alt="" style="width: 50px; height: 40px" :src="'/img/product/' + product.image_url" />
                          </td>
                          <td>
                            {{ product.brand_code }}
                          </td>
                          <td>
                            {{ product.description }}
                          </td>
                          <!-- <td>
                            {{ product.description_2 }}
                          </td> -->
                          <td>
                            {{ product.stock_unit_of_measure_code }}
                          </td>
                          <td>
                            {{ product.cat_code }}
                          </td>
                          <td>
                            {{ product.unit_price }}
                          </td>
                          <td>
                            {{ product.sup_code }}
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <hr />
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="modal-footer">
          <a v-print="'#printProduct'" class="btn-purchase btn-light text-capitalize border-0"
            data-mdb-ripple-color="dark"><i class="fas fa-print text-primary"></i> {{ i18ntext.lngText('print') }}</a>
        </div>
      </div>
    </div>
  </div>

  <!-- print product with varian code  -->

  <div class="modal fade ui-modal" id="printpart" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1"
    aria-labelledby="staticboomId" aria-hidden="true">
    <div class="modal-dialog">
      <div class="modal-content ui-dialog">
        <div class="ui-widget-header">
          <h5 class="modal-title in-header" id="staticBackdropLabel">
            <i class="fa fa-print" aria-hidden="true"></i> {{ i18ntext.lngText('print') }}
          </h5>
          <span class="ui-icon ui-icon-closethick" data-bs-dismiss="modal" aria-label="Close"></span>
        </div>
        <div class="ui-dialog-content">
          <div class="card">
            <div class="card-body print-size">
              <div class="mt-3" id="productDetail" style="height: auto !important">
                <div style="padding: 0 50px 0 50px">
                  <div class="col-md-12">
                    <div class="text-center">
                      <h3 class="title-purchase">{{ i18ntext.lngText('report') }}{{ i18ntext.lngText('product') }}</h3>
                    </div>
                  </div>
                  <div class="col-container">
                    <div class="col1" style="width: 55%">
                      <p class="p-bg font-size p-pad">{{ i18ntext.lngText('company') }}</p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('name') }} :</span>
                        <span id="fon">{{ company.company_name }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('phonenumber') }} :</span>
                        <span id="fon">{{ company.company_Phone }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('email') }} :</span>
                        <span id="fon">{{ company.company_Email }}</span>
                      </p>
                      <p class="p-mg info-pad">
                        <span id="bold">{{ i18ntext.lngText('address') }} :</span>
                        <span id="fon">{{ company.company_Address }}</span>
                      </p>
                    </div>
                    <div class="col2">
                      <p class="text-center p-bg font-size p-pad">{{ i18ntext.lngText('date') }}</p>
                      <p class="text-center p-mg" id="fon">{{ dateformart }}</p>
                      <p class="text-center p-bg font-size p-pad">
                        {{ i18ntext.lngText('total') }}{{ i18ntext.lngText('product') }}</p>
                      <p class="text-center p-mg" id="fon">
                        {{ dataObject.length }}
                      </p>
                    </div>
                  </div>

                  <div class="" v-for="(service, index) in dataObject" :key="index">
                    <ul class="d-flex test-ul">
                      <li style="width: 26%">
                        {{ i18ntext.lngText('product_no') }} :

                        <span class="li-span">{{ service.el.product_no }}</span>
                      </li>
                      <li style="width: 45%">
                        {{ i18ntext.lngText('description') }} :
                        <span class="li-span">{{ service.el.description }}</span>
                      </li>
                      <li style="width: 25%">
                        {{ i18ntext.lngText('diangosis') }} : <span class="li-span">{{ service.el.group_code }}</span>
                      </li>

                    </ul>
                    <table>
                      <thead>
                        <tr class="test-table" >
                          <th style="width: 10%">{{ i18ntext.lngText('no') }}</th>
                          <th>{{ i18ntext.lngText('quantity') }}</th>
                          <th style="width: 25%">{{ i18ntext.lngText('unittype') }}</th>
                          <th style="width: 15%">{{ i18ntext.lngText('unit_price') }}</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr v-for="(item, id) in service.items" class="test-table-tr">
                          <td style="width: 10%">{{ id + 1 }}</td>
                          <td style="width: 25%">{{ Number(item.quantity_per_unit).toLocaleString() }}</td>
                          <td style="width: 25%">{{ item.variant_unit_of_measure_code }}</td>
                          <td style="width: 15%">{{ Number(item.unit_price).toLocaleString() }}</td>
                        </tr>
                      </tbody>
                    </table>
                  </div>
                  <hr />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <a v-print="'#productDetail'" class="btn-purchase btn-light text-capitalize border-0"
            data-mdb-ripple-color="dark"><i class="fas fa-print text-primary"></i> {{ i18ntext.lngText('print') }}</a>
        </div>
      </div>
    </div>
  </div>

  <!-- end -->

  <Footer />
  <UserInfo />
</template>

<script>
import Logo from "../logo.vue";
import Header from "../Header.vue";
import Auth from "../../auth/Auth.js";
import readXlsxFile from "read-excel-file";
import * as XLSX from "xlsx-js-style";
import pagination from "laravel-vue-pagination";
import moment from "moment";
import axios from "axios";
import Footer from "../footer.vue";
import print from "vue3-print-nb";
import { MultiSelect } from "vue-search-select";
import { saveAs } from "file-saver";
import { ref, reactive, watch, computed, onMounted } from "vue";
import { invDependencies, log } from "mathjs";
import UserInfo from "../UserInfo.vue"
import i18n from "../../i18n/i18n";
const btnValue1 = ref(false);
const btnValue2 = ref(false);
const disabled = ref(true);
export default {
  components: { Header, pagination, Footer, MultiSelect, saveAs, Logo, UserInfo },
  directives: { print },
  data() {
    return {
      i18ntext: i18n,
      dataObject: [],
      vPro: '',
      viewID: "",
      isActive: "",
      options: [],
      itemss: [],
      photo_path: "",
      brands: [],
      graoups: [],
      category: [],
      suppliyers: [],
      uints: [],
      search: "",

      links: [],
      products: [],
      dateformart: "",
      company: [],
      perPage: "",
      currentPage: 0,
      last_page: 1,
      stockcount: 0,
      form: {
        product_no: "",
        product_barcode: "",
        description: "",
        description_2: "",
        image_url: "",
        stock_unit_of_measure_code: "",
        purche_unit_of_measure_code: "",
        brand_code: "",
        group_code: "",
        cat_code: "",
        sup_code: "",
        unit_price: "",
        inactived: "",
      },
      checkexcel: [],
      items: [
        {
          product_no: "",
          product_barcode: "",
          description: "",
          description_2: "",
          image_url: "",
          stock_unit_of_measure_code: "",
          purche_unit_of_measure_code: "",
          bom_no: "",
          reorder_point: "",
          sup_code: "",
          brand_code: "",
          group_code: "",
          cat_code: "",
          unit_price: "",
          inactived: "No",
          curency_code: "",
        },
      ],
      iteamLinks: [
        {
          product_no: "",
          description: "",
          description_2: "",
          image_url: "",
          variant_unit_of_measure_code: "",
          stock_unit_of_measure_code: "",
          quantity_per_unit: "",
          unit_price: "",
          curency_code: "",
          status: "",
          inactived: "",
        },
      ],
      checkarray: 1,
      excel: "Import",
      fileName: "PrucheseLine.xlsx",
      count_expire: 0,
      dataPrint: [],
      number_page : 1,
      search : {
        name : '',
        brand : '',
        unit : '',
        category : '',
        supplier : ''
      },
      brand : '',
      unit_code : '',
      category : '',
      supplier : '',
      number : 1,

    };
  },
  watch: {},
  mounted() {
    if (Auth.check()) {
      if (!Auth.checkPermission('PRODUCT_ALL')) {
        this.$router.push('/dashboard');
      }
    }
    if(this.$route.query.page != 1){
      this.number_page = this.$route.query.page
        axios.post("/api/v1/products/viewallproduct?page=" + this.number_page).then(({ data }) => {
          this.products = data.data;
          this.dataPrint = data.print
          this.dataObject = data.print_detail
        });
    }else{
      this.getproduct();
    }

    this.getstockalert();
    this.getunite();
    this.getdatagroup();
    this.getdatamodel();
    this.getCatName();
    this.getbrands();
    this.getsuppliyer();
    this.getcompany();
    this.getExpireAlert();

    let myPagenumber = this.$route.query
     if(JSON.stringify(myPagenumber) === '{}'){
        this.number = 1
     }
     else {
      this.number = this.$route.query.page
     }
  },

  methods: {
    async searchSupplier(search){
      if(search != ''){
        axios.get('api/v1/suppliyers/searchSupplier/'+search)
            .then(res => {
              this.suppliyers = res.data
            })
      }else{
        this.getsuppliyer();
      }
    },
    async searchCategory(search){
      if(search != ''){
        axios.get('api/v1/category/searchCategory/'+search)
            .then(res => {
              this.category = res.data
            })
      }else{
        this.getCatName()
      }
    },
    formatPrice(value, cur) {
    if (cur == "KHR") cur = "r";
        try {
            var formatter = new Intl.NumberFormat("en-US", {
                style: "currency",
                currency: cur,
                minimumFractionDigits: 2,
            });
            return formatter.format(value);
        } catch (error) {
            var formatter = new Intl.NumberFormat("en-US", {
                minimumFractionDigits: 2,
            });
            return formatter.format(value);
        }
    },
    async searchUnit(search){
      if(search != ''){
        axios.get('api/v1/unit/searchUnittype/'+search)
            .then(res => {
              this.uints = res.data
            })
      }else{
        this.getunite();
      }
    },
    async searchBrand(search){
      if(search != ''){
        axios.get('api/v1/brand/searchBrand/'+search)
            .then(res => {
              this.brands = res.data.data
            })
      }else{
        this.getbrands();
      }
    },
    checkEmpty(){
      if(this.search.name === ''){
        this.getproduct()
      }
      this.search  = {
        name : this.search.name,
        brand : '',
        unit : '',
        category : '',
        supplier : ''
      }
    },
    async getExpireAlert() {
      axios.get("api/v1/expireAlert").then((res) => {
        this.count_expire = res.data.stock.total;
      });
    },
    async test(x) {
      try {
        var y = x.split(",");
        for (var i = 0; i <= y.length; i++) {
          if (y[i].trim() != "undefined" && y[i] != "") {
            this.itemss.push({
              value: y[i],
              text: y[i],
            });
          }
        }
      } catch (error) { }
    },
    onSelect(x) {
      this.itemss = x;
      if (this.itemss.length >= 0) {
        this.form.group_code = "";
        x.forEach((e) => {
          if (e.value != null) {
            if (this.form.group_code == "") {
              this.form.group_code = e.value;
            } else {
              this.form.group_code = this.form.group_code + "," + e.value;
            }
          }
        });
        this.autoUpdateProduct(this.form);
      }
    },
    getproduct(page = 1) {
      this.$router.push({name: 'Viewproduct', query: {page : page}})

      axios.post("/api/v1/products/viewallproduct?page=" + page,this.search).then(({ data }) => {
        this.products = data.data;
        this.dataPrint = data.print
        this.dataObject = data.print_detail
        this.number = this.$route.query.page
        console.log(this.number)

      });
    },
    getproductsetting(boom, txt) {
      if (txt == "stockunit") {
        this.search.name = ""
        this.search.unit = boom.unit_code;
        this.search.supplier = "";
        this.search.category = "";
        this.search.brand = "";
      } else if (txt == "supplier") {
        this.search.supplier = boom.sup_name;
        this.search.unit = "";
        this.search.category = "";
        this.search.brand = "";
        this.search.name = ""
      } else if (txt == "groupproduct") {
        this.group_product = boom.group_name;
      } else if (txt == "category") {
        this.search.category = boom.cat_name;
       this.search.unit = "";
        this.search.supplier = "";
        this.search.name = ""
        this.search.brand = "";
      } else if (txt == "brand") {
        this.search.brand = boom.brand_name;
        this.search.unit = "";
        this.search.supplier = "";
        this.search.category = "";
      }
    },

    getstockalert() {
      axios.post("api/v1/stockcheck/checkOptionstock").then((response) => {
        this.stockcount = response.data.data.total;
      });
    },
    getunite() {
      axios.get("/api/v1/getunite").then((response) => {
        this.uints = response.data;
      });
    },
    getbrands() {
      axios.get("/api/v1/brands/getdata").then((response) => {
        this.brands = response.data;
      });
    },
    getdatagroup() {
      axios.get("/api/v1/progroups/getdatagroup").then((response) => {
        response.data.forEach((element) => {
          this.options.push({
            value: element.group_name,
            text: element.group_name,
          });
        });
      });
    },
    async getdatamodel() {
      await axios.get("/api/v1/promodel/getdatagroup").then((response) => {
        response.data.forEach((element) => {
          this.optionsmodel.push({
            value: element.group_name,
            text: element.group_name,
          });
        });
      });
    },
    getCatName() {
      axios.get("/api/v1/category/getCatName").then((response) => {
        this.category = response.data;
      });
    },
    getsuppliyer() {
      axios.get("/api/v1/suppliyers/getdatasub").then((response) => {
        this.suppliyers = response.data;
      });
    },

    getEdit(ProductID) {
      this.$router.push({ name: "Product", query: { id: ProductID } });
    },
    getDelete(id) {
      this.viewID = id.product_no;
      this.vPro = id;
      this.products.data.forEach((e) => {
        e.inactived = "Yes";
      });
    },
    DeletePro() {
      axios.post("/api/v1/products/update/" + this.viewID, this.vPro).then((response) => {
        alert('Delete Success')
      });
      this.getproduct();
    },







    async searchProduct(page = 1) {
      axios
        .get("/api/v1/products/productsearch?page=" + page, {
          form: this.form,
        })
        .then(({ data }) => {
          this.products = data.data;
        });
    },
    async getExcelData(event) {
      this.exefile = "";
      const titlered = document.getElementById("titlered");
      titlered.style.color = "326c7a";
      this.items = [];
      let xlsxfile = event.target.files ? event.target.files[0] : null;
      await readXlsxFile(xlsxfile).then((rows) => {
        var x = 0;
        rows.forEach((element) => {
          if (x >= 0) {
            if (x == 0) {
              this.checkexcel = element;
            } else {
              if (
                this.checkexcel[0] == "product_no" &&
                this.checkexcel[2] == "description" &&
                this.checkexcel[3] == "brand_code" &&
                this.checkexcel[4] == "group_code" &&
                this.checkexcel[5] == "cat_code" &&
                this.checkexcel[6] == "suppliyer_code" &&
                this.checkexcel[7] == "curency_code" &&
                this.checkexcel[8] == "stock_unit_of_measure_code" &&
                this.checkexcel[9] == "stock_unit_price" &&
                this.checkexcel[10] == "reorder_point"
              ) {
                this.items.push({
                  product_no: element[0],
                  product_barcode: element[1],
                  description: element[2],
                  brand_code: element[3],
                  group_code: element[4],
                  cat_code: element[5],
                  suppliyer_code: element[6],
                  curency_code: element[7],
                  stock_unit_of_measure_code: element[8],
                  unit_price: element[9],
                  reorder_point: element[10],
                  inactived: "No",
                });
                this.getLinkProduct(element);
              } else {
                this.exefile = " fail data ";
                titlered.style.color = "red";
              }
            }
          }
          x++;
        });
      });
      this.exefile = "";
    },
    async getLinkProduct(element) {
      this.addtolinkProduct(element, element[8], 1, element[9], "stock");
      var y = 11,
        z = 1;
      var xz1 = "quantity_unit" + z;
      var xz2 = "unit_code" + z;
      var xz3 = "unit_price" + z;
      if (element.length >= y) {
        while (y + 3 <= element.length) {
          if (
            this.checkexcel[y] == xz1 &&
            this.checkexcel[y + 1] == xz3 &&
            this.checkexcel[y + 2] == xz2
          ) {
            this.addtolinkProduct(
              element,
              element[y + 2],
              element[y],
              element[y + 1],
              "unit"
            );
            z++;
            xz1 = "quantity_unit" + z;
            xz2 = "unit_code" + z;
            xz3 = "unit_price" + z;
          }
          y = y + 3;
        }
      }
    },
    addtolinkProduct(element, measure_code, quantity, price, statuse) {
      this.iteamLinks.push({
        product_no: element[0],
        product_barcode: element[1],
        description: element[2],
        variant_unit_of_measure_code: measure_code,
        stock_unit_of_measure_code: element[8],
        quantity_per_unit: quantity,
        unit_price: price,
        curency_code: element[7],
        status: statuse,
        inactived: "No",
      });
    },
    saveprulink() {
      if (this.items.length > 0) {
        setTimeout(() => this.savepro(), 2000);
      }
    },
    async savepro() {
      this.items.forEach((element) => {
        if (element.product_no != "" && element.description != "") {
          element.created_by = Auth.user.user_code;
          axios.post("api/v1/products/saveDataFformexcel/", element).then((response) => {
            this.massege =
              this.items[this.checkarray - 1].product_no +
              " / " +
              this.items[this.checkarray - 1].description;
            this.massege +=
              " : " +
              this.items[this.checkarray].product_no +
              " / " +
              this.items[this.checkarray].description;
            this.massege +=
              " : " +
              this.items[this.checkarray + 1].product_no +
              " / " +
              this.items[this.checkarray + 1].description;
            this.products = response.data;
            this.savedataValincode(element.product_no);
          });
        }
      });
      if (this.checkarray < this.items.length) {
        this.saveprulink();
        this.checkarray++;
        this.meassagechek("open");
      } else {
        this.meassagechek("close");
        this.checkarray = 0;
      }
    },
    meassagechek(check) {
      var modal = document.getElementById("myModalauto");
      if (check == "open") {
        modal.style.display = "block";
      } else {
        modal.style.display = "none";
      }
    },
    savedataValincode(product_no) {
      this.iteamLinks.forEach((element) => {
        element.created_by = Auth.user.user_code;
        if (element.product_no == product_no && element.product_no != "") {
          axios
            .post("api/v1/products/SaveDataLinkexcel/", element)
            .then((response) => { });
        }
      });
    },
    getcompany() {
      axios.get("/api/v1/getSetup/").then((response) => {
        this.company = response.data;
        this.dateformart = moment(new Date()).format("DD-MM-YYYY");
      });
    },
    save() {
      this.excel = "Import";
      this.productline = 0;
      this.total = 0;
      this.items = [];
      this.item = 0;
    },
    exportSheet() {
      this.excel = "Export";
      this.items = [];
      axios.get("/api/v1/product/getTypeproduct").then((res) => {
        res.data.forEach((element) => {
          if (element.unit_price == null || element.unit_price == "") {
            element.unit_price = 0;
          }

          var sp = element.unit_price + element.curency_code;
          var sp1 = element.inventory + element.stock_unit_of_measure_code;
          this.items.push({
            product_no: element.product_no,
            brand_code: element.brand_code,
            description: element.description,
            description_2: element.description_2,
            cat_code: element.cat_code,
            unit_price: sp,
            inventory: sp1,
            sup_code: element.sup_code,
            type: element.type,
            reorder_point: element.reorder_point,
            group_code: element.group_code,
          });
        });
      });
    },
    exportdataExcel() {
      const invoices = this.items.reduce((ac, element) => {
        if (element.unit_price == null || element.unit_price == "") {
          element.unit_price = 0;
        }

        var sp = element.unit_price;
        var sp1 = element.inventory;
        if (element.brand_code == null || element.brand_code == "") {
          element.brand_code = "null";
        }
        if (element.description == null || element.description == "") {
          element.description = "null";
        }
        if (element.description_2 == null || element.description_2 == "") {
          element.description_2 = "null";
        }
        if (element.cat_code == null || element.cat_code == "") {
          element.cat_code = "null";
        }
        if (element.sup_code == null || element.sup_code == "") {
          element.sup_code = "null";
        }
        if (element.group_code == null || element.group_code == "") {
          element.group_code = "null";
        }
        if (element.reorder_point == null || element.reorder_point == "") {
          element.reorder_point = 0;
        }
        ac.push({
          Product: element.product_no,
          Barcode: element.product_no,
          GenericName: element.description,
          NameKH: element.description_2,
          Brand: element.brand_code,
          Diangosis: element.group_code,
          Category: element.cat_code,
          Supplyer: element.sup_code,
          StockOnHand: sp1,
          Price: sp,
          Piont: element.reorder_point,
          ProductType: element.type,
        });
        return ac;
      }, []);

      var invoicesWS = XLSX.utils.json_to_sheet(invoices, { origin: "A10", raw: true });
      var wb = XLSX.utils.book_new();
      XLSX.utils.sheet_add_aoa(
        invoicesWS,
        [
          ["PRODUCTS"],
          ["COMPANY NAME"],
          ["NAME : Cambo Pharma"],
          ["PHONE NUMBER : (+855)12 381215"],
          ["EMAIL ADDRESS : Cambo.pharma@gmail.com"],
          ["ADDRESS : ត្រើយកោះ ស្រុកទឹកឈូ ខេត្តកំពត"],
          ["DATE"],
          [new Date()],
        ],
        { origin: "A1", display: false, dateNF: "DD-MM-YYYY", cellDates: false }
      );

      var wscols = [
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
        { width: 20 },
      ];
      invoicesWS["!cols"] = wscols;

      var merge = [
        { s: { c: 0, r: 0 }, e: { c: 11, r: 0 } },
        { s: { c: 0, r: 1 }, e: { c: 11, r: 1 } },
        { s: { c: 0, r: 2 }, e: { c: 11, r: 2 } },
        { s: { c: 0, r: 3 }, e: { c: 11, r: 3 } },
        { s: { c: 0, r: 4 }, e: { c: 11, r: 4 } },
        { s: { c: 0, r: 5 }, e: { c: 11, r: 5 } },
        { s: { c: 0, r: 6 }, e: { c: 11, r: 6 } },
        { s: { c: 0, r: 7 }, e: { c: 11, r: 7 } },
        { s: { c: 0, r: 8 }, e: { c: 11, r: 8 } },
      ];
      invoicesWS["!merges"] = merge;
      XLSX.utils.book_append_sheet(wb, invoicesWS, "Product");
      var x = wb.Sheets.Product;
      for (var row in x) {
        const style = x[row];
        try {
          style.s = {
            alignment: { horizontal: "right", vertical: "right", wrapText: true },
            border: {
              top: { style: "thin" },
              right: { style: "thin" },
              bottom: { style: "thin" },
              left: { style: "thin" },
            },
          };
        } catch (error) { }
      }
      x["A1"].s = {
        font: {
          name: "Segoe UI Variable Display Semib",
          sz: 16,
          bold: true,
          color: { rgb: "326c7a" },
        },
        alignment: { horizontal: "center", vertical: "center" },
      };
      x["A2"].s = {
        font: { name: "Segoe UI Variable Display Semib", sz: 16, bold: true },
        fill: { fgColor: { rgb: "8DD5E8" } },
        alignment: { horizontal: "center", vertical: "center" },
      };
      x["A7"].s = {
        font: { sz: 12, bold: true },
        alignment: {
          name: "Bahnschrift SemiLight SemiConde",
          horizontal: "center",
          vertical: "center",
        },
        fill: { fgColor: { rgb: "8DD5E8" } },
      };
      const sheet = ["A3", "A4", "A5", "A6", "A8"];
      for (var sheets of sheet) {
        x[sheets].s = {
          font: { name: "Bahnschrift SemiLight SemiConde", sz: 12 },
          fill: { fgColor: { rgb: "ffffff" } },
          alignment: { horizontal: "center", vertical: "center" },
        };
      }
      const colName = [
        "A10",
        "B10",
        "C10",
        "D10",
        "E10",
        "F10",
        "G10",
        "H10",
        "I10",
        "J10",
        "K10",
        "L10",
      ];
      for (var itm of colName) {
        x[itm].s = {
          font: { name: "Bahnschrift SemiLight SemiConde", sz: 12, bold: true },
          fill: { fgColor: { rgb: "8DD5E8" } },
          border: {
            top: { style: "thin" },
            right: { style: "thin" },
            bottom: { style: "thin" },
            left: { style: "thin" },
          },
        };
      }
      XLSX.writeFile(wb, "Products.xlsx");
    },
  },
};
</script>
